SystemOrganization addCategory: #TpObjetos!

Object subclass: #Alumno
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos temasImprescindibles calificacion esponja'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

Alumno class
	instanceVariableNames: 'atencion motivacion animo estado temasAprendidos calificacion'!

!Alumno class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 21:55'!
new
	|alumno|
	alumno := super new.
	alumno inicializar.
	^alumno.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:58'!
animar
(estado = nil) ifTrue: [self estado: 1].
self animo: (Estados dameEstado: (estado+1)).
self estado: (estado+1).! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
animo
^animo.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/20/2012 03:18'!
animo: unEstado
animo := unEstado.! !

!Alumno methodsFor: 'Do' stamp: 'Damian 10/21/2012 23:17'!
aprender: unTema

(unTema temasPrevios isNil | (unTema temasPrevios) allSatisfy: [:tema | (self temasAprendidos) includes: tema])

ifTrue: 
(unTema class = Complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumno methodsFor: 'Do' stamp: 'Damian 10/21/2012 23:19'!
aprenderImprescindible: unTema

((unTema class) = Complejo)
	 ifTrue: [((atencion >= (0.9*(unTema interes)) & (motivacion)))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + ((unTema interes)/2) ).
					self motivar.
					self animar]]
		
	ifFalse: [((unTema estado = animo) & (atencion > 50))
			ifTrue: [temasAprendidos add: unTema.
					temasImprescindibles add: unTema.
					self atencion: (atencion + 10).
					self motivar.
					self animar]].! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
atencion
^atencion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/24/2012 21:20'!
atencion: unNumero
(unNumero >100) ifTrue: [atencion := 100]
ifFalse: [atencion := unNumero].! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 03:00'!
calificacion
^calificacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/11/2012 22:48'!
calificacion: unNumero
(unNumero >= 4) 	ifTrue: [calificacion := unNumero]
					ifFalse: [calificacion := 2].
(calificacion = 10)	ifTrue: [esponja := true]
					ifFalse: [esponja := false].! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:58'!
desanimar
(estado = nil) ifTrue: [self estado: 1].
self animo: (Estados dameEstado: (estado-1)).
self estado: (estado-1).! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
desmotivar
motivacion := false.! !

!Alumno methodsFor: 'Setters' stamp: 'Demian 10/16/2012 10:45'!
duplicarAtencion
	atencion := atencion * 2.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:31'!
estado
^estado.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:46'!
estado: unNumero
(unNumero > (Estados max))
ifTrue: [estado := (Estados max)]
ifFalse: [(unNumero <1) 
	ifTrue: [estado := 1] 
	ifFalse: [estado := unNumero]].! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 21:50'!
inicializar
	temasAprendidos := Set new.
	temasImprescindibles := Set new.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 17:34'!
invertirMotivacion
motivacion :=  motivacion not.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 02:53'!
motivacion
^motivacion.! !

!Alumno methodsFor: 'Setters' stamp: 'LeoComparin 9/23/2012 04:53'!
motivar
motivacion := true.! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/23/2012 03:44'!
new
^super new initialize! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 06:34'!
temas
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:11'!
temasAprendidos
^temasAprendidos.! !

!Alumno methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 20:02'!
temasImprescindibles
^temasImprescindibles.! !

Object subclass: #Clase
	instanceVariableNames: 'curso'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Clase class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 18:57'!
para: unCurso
|unaClase|

unaClase := self new.
unaClase curso: unCurso.
^unaClase.! !

!Clase methodsFor: 'Setters' stamp: 'Demian 10/16/2012 10:15'!
alegoria
	curso alumnos do: [:unAlumno | 
		((unAlumno atencion) > 30) 
			ifTrue:
			[unAlumno atencion: ((unAlumno atencion) +10).
			unAlumno motivar]
		
			ifFalse: [unAlumno desanimar; motivar]].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:25'!
analogia
curso alumnos do: [:unAlumno | 
	((unAlumno atencion) > 30) 
		ifTrue:
		[unAlumno atencion: ((unAlumno atencion) +10).
		unAlumno motivar]
		
		ifFalse: [unAlumno desanimar]].! !

!Clase methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:07'!
curso
^curso.! !

!Clase methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:54'!
curso: unCurso
curso := unCurso.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:41'!
diapositivas
"Explicar un tema mediante diapositivas. Aumenta la atencion de todo el curso un 20%, pero si el alumno se quiere ir o esta mas o menos se desmotiva"

curso alumnos do: [:unAlumno | 
	((unAlumno animo = (Estados mostrarEstados at: 1)) | (unAlumno animo = (Estados mostrarEstados at: 2))) 	ifTrue: [unAlumno desmotivar].
	unAlumno atencion: ((unAlumno atencion)*1.2)].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 01:10'!
ejercitar
"Dar ejercicios para resolver en clase. Si el alumno esta motivado mejora su estado de animo y su nivel de atencion sube a 80 a menos que sea mayor, en ese caso queda igual. 
En caso contrario, si el alumno esta desmotivado, automaticamente quiere irse y su nivel de atencion baja a un 30% de este"

curso alumnos do: [:unAlumno | 
	(unAlumno motivacion) 
	ifTrue: [unAlumno animar.
	(unAlumno atencion <80) ifTrue: [unAlumno atencion: 80]]

	ifFalse: [unAlumno animo: (Estados mostrarEstados at: 1).
	unAlumno atencion: (unAlumno atencion)*0.3]].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicar: unTema
curso teDoy: unTema.! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:38'!
explicarImprescindible: unTema
curso teDoyImp: unTema.! !

!Clase methodsFor: 'Setters' stamp: 'Demian 10/16/2012 11:07'!
hacerRepresentacion
	| alumnosDesmotivados alumnosMotivados estaMotivado seQuierenIr alumnosSeQuierenIr alumnosADesanimar |
	curso alumnos do: [:alumno | alumno duplicarAtencion].
	estaMotivado := [:alumno | alumno motivacion].
	alumnosMotivados  := curso alumnos select: estaMotivado.
	alumnosDesmotivados :=  curso alumnos reject: estaMotivado.
	alumnosMotivados do: [:alumno | alumno desmotivar].
	alumnosDesmotivados do: [:alumno | alumno motivar].
	
	seQuierenIr := [:alumno | alumno estado = 1].
	alumnosSeQuierenIr := curso alumnos select: seQuierenIr.
	alumnosADesanimar := curso alumnos reject: seQuierenIr.
	alumnosADesanimar do: [:alumno | alumno desanimar].
	alumnosSeQuierenIr  do: [:alumno | alumno estado: 6].! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:43'!
payasada
curso alumnos do: [:unAlumno |
	unAlumno atencion: ((unAlumno atencion) *2).
	unAlumno invertirMotivacion.
	((unAlumno animo) = (Estados mostrarEstados at:4)) ifTrue: [unAlumno animo: (Estados mostrarEstados at:1)]
	ifFalse: [unAlumno animar]].
! !

!Clase methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:46'!
receso: unTiempo
curso alumnos do: [:unAlumno | 
			unAlumno atencion:  ((unAlumno atencion) + unTiempo).
			(((unAlumno animo) = (Estados mostrarEstados at:1) | (unAlumno animo) = (Estados mostrarEstados at:2)) & ((unAlumno atencion) < 50)) 
			ifTrue: [unAlumno atencion: ((unAlumno atencion) *2)]
			ifFalse: [unAlumno animar]].! !

Object subclass: #Curso
	instanceVariableNames: 'alumnos docente temasVistos temasImprescindibles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Curso class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 18:12'!
nuevo
| unCurso |

unCurso  := self new.
unCurso comenzarCurso.
^unCurso.! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:09'!
alumnos
^alumnos.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 21:02'!
aprobados
| aprobados |

aprobados := (alumnos select: [:alum | alum calificacion >=4])size.
(alumnos size >0) ifTrue: [^(aprobados/(alumnos size)*100)asFloat].! !

!Curso methodsFor: 'Setters' stamp: 'Damian 10/21/2012 18:44'!
comenzarCurso
alumnos := Set new.
temasVistos := Bag new.
temasImprescindibles := Set new.! !

!Curso methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 19:05'!
docente
^docente.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/11/2012 21:04'!
evaluacion
	| materias totales |

totales := (docente temasTotales size).
alumnos do: [:unAlumno | materias := (unAlumno temasAprendidos size).
			((unAlumno temasImprescindibles size ) = (temasImprescindibles size)) ifTrue: 
			[unAlumno calificacion: (( materias / totales ) * 10)asFloat]
	
			ifFalse: [unAlumno calificacion: 2]].! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:15'!
inscribir: unAlumno
alumnos add: unAlumno.! !

!Curso methodsFor: 'Setters' stamp: 'Demian 10/19/2012 12:30'!
porcAprendieron: tema
	^60! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:32'!
teDoy: unTema
alumnos do: [:unAlumno| unAlumno aprender: unTema].
docente agregarTema: unTema.
temasVistos add: unTema.! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:32'!
teDoyImp: unTema
alumnos do: [:unAlumno| unAlumno aprenderImprescindible: unTema].
docente agregarTema: unTema.
temasVistos add: unTema.
temasImprescindibles add: unTema.
! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/4/2012 18:20'!
temaMenosAprendido
| ordenados |

ordenados := docente temasTotales asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Do' stamp: 'LeoComparin 10/5/2012 01:30'!
temaMenosAprendidoVarias
| ordenados varios|

varios := temasVistos select: [:unTema | (temasVistos occurrencesOf: unTema ) >1].

ordenados := varios asSortedCollection: [:a :b | (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: a)]) <  (alumnos inject: 0 into: [:aparece :unAlumno | aparece +  (unAlumno temasAprendidos occurrencesOf: b)])].

(ordenados size >=1)
ifTrue: [ ^ ordenados first nombre] .! !

!Curso methodsFor: 'Getters' stamp: 'LeoComparin 10/4/2012 18:11'!
temasVistos
^temasVistos.! !

!Curso methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 19:05'!
tuDocenteEs: unDocente
docente := unDocente.! !

!Curso methodsFor: 'Getters' stamp: 'Demian 10/19/2012 12:21'!
ultimoTemaVisto
	^ self temasVistos last.! !

Object subclass: #Docente
	instanceVariableNames: 'temasTotales temasIndispensables planificacionTemas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Docente class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 9/25/2012 00:26'!
nuevo
| unDocente |

unDocente := self new.
unDocente comenzarCurso.
^unDocente.! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:44'!
agregarTema: unTema
temasTotales add: unTema.! !

!Docente methodsFor: 'Getters' stamp: 'Demian 10/19/2012 11:31'!
clasesEn: facultad
	^ (facultad Clases select: [:clase | (clase curso) docente = self])! !

!Docente methodsFor: 'Setters' stamp: 'LeoComparin 10/4/2012 18:49'!
comenzarCurso
temasTotales := Set new.! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:57'!
planificacionTemas
	^planificacionTemas.! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 17:19'!
planificacionTemas: temas
	planificacionTemas:= temas.! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:56'!
temasIndispensables
	^temasIndispensables! !

!Docente methodsFor: 'Setters' stamp: 'Damian 10/21/2012 17:18'!
temasIndispensables: temas
	temasIndispensables:= temas! !

!Docente methodsFor: 'Getters' stamp: 'LeoComparin 9/23/2012 19:15'!
temasTotales
^temasTotales.! !

!Docente methodsFor: 'Getters' stamp: 'Damian 10/21/2012 17:17'!
temasTotales: temas 
	temasTotales:= temas.
! !

Docente subclass: #Estructurado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Estructurado methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 18:37'!
capacitarse
	|piola|
	piola := Piola new.
	piola temasIndispensables: self temasIndispensables.
	piola planificacionTemas: self planificacionTemas.
	piola temasTotales: self temasTotales.
	^piola
! !

!Estructurado methodsFor: 'as yet unclassified' stamp: 'Demian 10/19/2012 12:58'!
darClasesEn: facultad explicar: tema
	| cursosDocente |
	cursosDocente := self clasesEn: facultad.
	cursosDocente do: [:clase | (clase curso) explicar: tema; receso: facultad tiempoRecesos; ejercitar].! !

Docente subclass: #Piola
	instanceVariableNames: 'porcentajeSuficiente tiempoRecesos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Piola methodsFor: 'as yet unclassified' stamp: 'Demian 10/19/2012 17:07'!
darClasesEn: facultad explicar: tema
	| clasesDocente ultimoTema |
	clasesDocente := self clasesEn: facultad.
	clasesDocente do: [:clase | 
		ultimoTema := clase curso ultimoTemaVisto.
		clase curso porcAprendieron: ultimoTema 	< porcentajeSuficiente
			ifTrue: [clase analogia; explicar: ultimoTema]
			ifFalse: [clase ejercitar; alegoria].
		clase  receso: tiempoRecesos.
		clase explicar: tema.
		clase ejercitar.].! !

Object subclass: #Estados
	instanceVariableNames: ''
	classVariableNames: 'Estados Max'
	poolDictionaries: ''
	category: 'TpObjetos'!

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:47'!
dameEstado: unNumero
(unNumero > Max)
ifTrue: [^Estados at: Max]
ifFalse: [(unNumero <1) 
	ifTrue: [^Estados at: 1] 
	ifFalse: [^Estados at: unNumero]].! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'Demian 10/16/2012 09:48'!
iniciarEstados
Estados := OrderedCollection new.
Estados add: 'me quiero ir'.
Estados add: 'que mal la estoy pasando'.
Estados add: 'mas o menos'.
Estados add: 'todo bien'.
Estados add: 'muy bien'.
Estados add: 'con ganas de ser ayudante'.
Max := 6.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:43'!
max
^Max.! !

!Estados class methodsFor: 'as yet unclassified' stamp: 'LeoComparin 10/4/2012 19:33'!
mostrarEstados
^Estados.! !

Object subclass: #Facultad
	instanceVariableNames: 'clases tiempoRecesos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Facultad class
	instanceVariableNames: 'cursos'!

Facultad class
	instanceVariableNames: 'cursos'!

!Facultad class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:26'!
new
	| facultad |
	facultad := super new.
	facultad inicializar.
	^facultad! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Demian 10/19/2012 11:06'!
agregar: curso
	Clases add: curso.! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 19:45'!
capacitar: docente
	docente primitiveChangeClassTo: Piola.! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Demian 10/19/2012 11:06'!
clases
	^Clases! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:29'!
inicializar
	clases := Set new.
	tiempoRecesos := 20.! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:30'!
invertir: tema
	tema class = Complejo 
	ifTrue:  [^true].! !

!Facultad methodsFor: 'as yet unclassified' stamp: 'Demian 10/18/2012 14:26'!
tiempoRecesos
	^tiempoRecesos.! !

Object subclass: #Tema
	instanceVariableNames: 'nombre temasPrevios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

Tema subclass: #Complejo
	instanceVariableNames: 'interes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Complejo methodsFor: 'Getters' stamp: 'Damian 10/21/2012 23:14'!
interes
^interes.! !

!Complejo methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:14'!
interes: unNumero
(unNumero >100) ifTrue: [interes := 100]
ifFalse: [interes := unNumero].! !

Tema subclass: #Simple
	instanceVariableNames: 'estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpObjetos'!

!Simple methodsFor: 'Getters' stamp: 'Damian 10/21/2012 23:16'!
estado
^estado.! !

!Simple methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:16'!
estado: algo
estado := algo.! !

!Simple methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:16'!
estadoNum: unNumero
| algo |

(unNumero > (Estados max))
ifTrue: [algo := (Estados mostrarEstados at:  (Estados max))]
ifFalse: [(unNumero <1) 
	ifTrue: [algo := (Estados mostrarEstados at: 1)] 
	ifFalse: [algo := (Estados mostrarEstados at: unNumero)]].

estado := algo.! !

!Tema class methodsFor: 'as yet unclassified' stamp: 'Damian 10/21/2012 23:46'!
new: unNombre
	|tema|
	tema := self new.
	tema inicializar: unNombre.
	^tema! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/21/2012 23:42'!
inicializar: unNombre
	temasPrevios := Set new.
	nombre := unNombre.! !

!Tema methodsFor: 'Getters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre
^nombre.! !

!Tema methodsFor: 'Setters' stamp: 'LeoComparin 9/25/2012 02:26'!
nombre: unNombre
nombre := unNombre .! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/21/2012 16:32'!
temasPrevios
	^temasPrevios.! !

!Tema methodsFor: 'Setters' stamp: 'Damian 10/21/2012 21:36'!
temasPrevios: temas
	temasPrevios add: temas.! !
